//#include <LinkedList.h>
class FeasibleSoln{
    public:
        FeasibleSoln();
        ~FeasibleSoln();
        int numShapes();
        LinkedList* getShapesPromRegion();
        shapes getShape(int i);
        LinkedList* getShapesPromRegionNoDups()
    private:
        LinkedList* shape;
        LinkedList* shapeValues;

        LinkedList* memoryShapes;
        LinkedList* memoryShapeValues;
        bool usedAllowedShapes[1000];
        int numUsedAllowedShapes;
};

FeasibleSoln::FeasibleSoln() {
  for (int i = 0; i < 1000; i++)
	 usedAllowedShapes[i]= false;
}

FeasibleSoln::~FeasibleSoln(){
}

int FeasibleSoln::numShapes(){
    return (*shape).size();
}

// return all shapes, including duplicates
LinkedList* FeasibleSoln::getShapesPromRegion(){
    LinkedList* tmp= memoryShapes; 
    for (int i = 0; i < (*shapeValues).size(); i++)
        (*tmp).insert((*shapeValues).get(i));
    return tmp;
}

shapes FeasibleSoln::getShape(int i){
    return ((*shape).get(i));
}

LinkedList* FeasibleSoln::getShapesPromRegionNoDups(){
    LinkedList* tmp= memoryShapes;
    for (int i = 0; i < (*shapeValues).size(); i++)
        (*tmp).insert((*shapeValues).get(i));

    for (int i = 0; i < (*tmp).size(); i++){
        shapes m= tmp->get(i);
        for (int j = 0; j < tmp->size(); i++){
            shapes n= tmp->get(j);
            // check if m == n
            boolean same= true;
            if (m.start != n.start)
                same = false;
            else
                for (int k = m.start; k< m.end && same; k++){
                    if (m.left_index[k] != n.left_index[k])
                        same= false;
                    if (same && m.right_index[k] != n.right_index[k])
                        same= false;
                    }
            if (!same)
                cout << "Removing a shape\n"
            if (same)
                tmp->remove(j);
        }
    }
}

